#include "synthesizer.h"

//von 'A bis c'''' 64 tne; Angaben in 44100/Freq, gerundet                  
unsigned short freq[] = {
//c  cis   d   dis   e    f   fis   g   gis   a  ais/b  h
                                             802, 757, 714, //'X
674, 636, 601, 567, 535, 505, 477, 450, 425, 401, 378, 357, // X
337, 318, 300, 283, 268, 253, 238, 225, 212, 220, 189, 179, // x
169, 159, 150, 142, 134, 126, 119, 113, 106, 100,  95,  89, // x'
 84,  80,  75,  71,  67,  63,  60,  56,  53,  50,  47,  45, // x''
 42,  40,  38,  35,  33,  32,  30,  28,  27,  25,  24,  22, // x'''
 21                                                         // x''''
                    };

unsigned char GetPWM(PolyStream* stream)
{
    unsigned char i = stream->len - 1;
    unsigned short pwm = 0;
    do
    {
        pwm += GetTone(&(stream->stream[i]));
    }
    while(i--);
    pwm = pwm >> stream->loglen;
    return (unsigned char)pwm;
}

unsigned char GetTone(Stream* stream)
{
    unsigned short tonefreq = freq[stream->stream[stream->streampos].tone];
    if(++stream->tonepos == stream->stream[stream->streampos].len) //Ton zu Ende?
    {
        stream->tonepos = 0;    //Werte zurcksetzen
        stream->tonepwmpos = 0;
        stream->streampos++;   //nchster Ton
        while(stream->stream[stream->streampos].len == 0)
            if(++stream->streampos == stream->len)
                return 128;
        stream->tonemax = freq[stream->stream[stream->streampos].tone] << 1;
    }
    if(stream->streampos >= stream->len)    //Stream zuende?
        return 128;                         //Lautlos
    if(tonefreq > ++stream->tonepwmpos) //pos unter Schwellwert?
        return stream->stream[stream->streampos].volume;
    else
        if(stream->tonepwmpos == stream->tonemax) //Max Wert erreicht/berschritten?
            stream->tonepwmpos = 0; //pwmpos zurcksetzen
    return 255 - stream->stream[stream->streampos].volume; //-volume zutckgeben
}

Tone CreateTone(unsigned char tone, unsigned char volume, unsigned int len)
{
    Tone t;
    t.tone = tone;
    t.volume = volume;
    t.len = len;
    return t;
}
Stream CreateStream(Tone* stream, unsigned short len)
{
    Stream s;
    s.stream = stream;
    s.len = len;
    s.streampos = s.tonepwmpos = s.tonepos = 0;
    s.tonemax = freq[stream[0].tone] << 1;
    return s;  
}
PolyStream CreatePolyStream(Stream* stream, unsigned char loglen)
{
    PolyStream p;
    p.stream = stream;
    p.loglen = loglen;
    p.len = 1 << loglen;
    return p;
}
