#ifndef SYNTH
#define SYNTH

#include <stdio.h>

#define TONE_MODE_PLAY 0
#define TONE_MODE_DELAY 1
#define TONE_MODE_END 2

struct Tone
{
    unsigned char tone;
    unsigned char volume;
    unsigned int len;
};

struct Stream
{
    Tone* stream;
    unsigned short len;
    unsigned short streampos;
    unsigned short tonepwmpos;
    unsigned short tonepos;
    unsigned short tonemax;
};

struct PolyStream
{
    Stream* stream;
    unsigned char len;
    unsigned char loglen;   
};

unsigned char GetPWM(PolyStream* stream);
unsigned char GetTone(Stream* stream);

Tone CreateTone(unsigned char tone, unsigned char volume, unsigned int len);
Stream CreateStream(Tone* stream, unsigned short len);
PolyStream CreatePolyStream(Stream* stream, unsigned char loglen); //1<<loglen ^= len(stream) 

#endif
